#!/usr/bin/perl -W


##---------------------------------------------------------------------------------
##Array Networks
##Tongjj
##April 2018
##Tool to rebrand ThemeMP
##---------------------------------------------------------------------------------


use strict;
use warnings;

#~ if($#ARGV ne 0){
	#~ print 'usage: <target directory>\n';
	#~ exit;
#~ }

#global variables

#string
my ($target_floder,$listfile,$prefix_company);
#int
my ($filecount);
#array
my (@change_pair,@change_pair_build,@build_script);

#initialization for above 
#$target_floder = 'windows/shared/include';#will be replaced by $ARGV[0]
$target_floder = '.';#will be replaced by $ARGV[0]
$prefix_company = '..\\oem\\infosec\\';
$listfile = $prefix_company.'filelist_thememp.txt';
$filecount = 0;

#Note;
#Element 0 is the pattern, Element 2 is the replacement
#Order is VERY IMPORTANT!!! Keep "array" at the last one
#Case Sensitive
@change_pair = (
		['Array Networks, Inc.','Infosec Technologies Co.,Ltd.'],
		['Array Networks Inc.','Infosec Technologies Co.,Ltd.'],
		['Array Networks','Infosec Technologies'],
		['Array NetWorks','Infosec Technologies']
	);
#for build script
@change_pair_build = (
		['array_netscape_cert.p12','Infosec2013.pfx'],
		['click1','infosec2013'],
		['Array Networks Client Software','Infosec NetGate Client Software'],
		['Array Networks','Infosec Technologies'],		
		['www.arraynetworks.net','www.infosec.com.cn']
	);
#list of build scripts
@build_script = (
		'AutoBuild.bat',
	);
#['',''],array_netscape_cert.p12

sub go_though{
        
	#Breadth first search
	my $pwd = $_[0];
	my @dirs = ($pwd.'/');	  
	my ($dir, $file);	
	while ($dir = pop(@dirs)) {
		local *INDDIR;
		if (!opendir(INDIR, $dir)) {
			warn "Cannot opendir $dir: $! $^E";
			next;
		}
		#print readdir(INDIR)."\n";
		foreach (readdir(INDIR)) {
			if($_ eq '.' || $_ eq '..' || 
				$_ =~ /ldappasschange|logout|passchange|smx|static|theme_error|welcome|css|default|lib/){
				#escape the above folders
				next;
			}
			$file = $dir.$_;   			
			if (!-l $file && -d _) {#it's a folder
				#print $file."\n";
				$file .= '/';
				#print $file."\n";
				push(@dirs, $file);
			}
			else{#it's a file
				#print $file."\n";
				if($file =~ /\.html/ || $file =~ /\.js/){
					#check the extension of files
					#only handle cpp, c, header, rc ,inf file
					process_file($file);	
				}
				else{
					#print "skip file $file\n";
				}
			}
		}#end foreach
		closedir(INDDIR);
	}#end while loop
}#end go_though







sub process_file{
	my $file = $_[0];
	#my $dir = $_[1];
	my $out = '';
	my $lineNum = 1;
	
	#print "Processing file: $file\n";
	#print "==================\n";
	open(INPUT, "<$file") or die "ERROR:Cannot read file: $file";
	while(my $line = <INPUT>){#read file line by line
		#print $line."\n";
		for my $i ( 0 .. $#change_pair ) {
			my $pattern = $change_pair[$i]->[0];
			my $target = $change_pair[$i]->[1];
			if($line =~ /$pattern/){
				if($line !~ /fd_array/){
					print "\n";
					print "Replace Pattern: \"$pattern\" to Target: \"$target\" at Line: $lineNum\n";
					my $tmp = trim($line);
					print "Original: $tmp\n";
					$line =~ s/$pattern/$target/g;#global replace the matched string and print out the line number 
					$tmp = trim($line);
					print "Modified: $tmp\n";
					print "\n";
					#$i  = $#change_pair;#do I need it?
				}
			}   
		}
		$out .= $line;
		$lineNum++;
	}	
	system("attrib -R $file");
	open(OUTPUT, ">$file") or die "ERROR:Cannot write file: $file";
	print OUTPUT $out;
	close OUTPUT;
	close INPUT;
	#print $file."\n";
	#print "==================\n\n";
	$filecount++;
	
}#end process)file

sub trim($){
	# trim function to remove leading and trailing whitespace and trailing new line char "\n"
	my $string = shift;
	$string =~ s/\s+$//;
	$string =~ s/^\s+//;
	$string =~ s/\\n+$//;
	return $string;
}

#main function go here
print "\n*******Beging to rewrited *.cpp, *.c, *.rc, *.h files*******\n";
	go_though($target_floder);
print "\nTotal file number: $filecount files\n";
print "\n*******Rewriting finished successful*******\n";


print "\n**************Replacing files**************\n\n";
	open(FILELIST, "<$listfile") or die "Read file list $listfile failed!";
	my @file_contents = <FILELIST>;
	chomp  @file_contents;
	close(FILELIST);
	
	for my $file (@file_contents) {
		my @list = split(/[ \t]*->[ \t]*/,$file);
		if ($list[0] && $list[1]) {
			my $filename = $prefix_company.$list[0];
			my $outfile = $list[1];	
			$filename = trim($filename);
			$outfile = trim($outfile);
			if (-f $filename && -f $outfile) {
				print "copy and replace $filename to $outfile\n";
				system("attrib -R $outfile");
                                system("COPY /Y $filename $outfile");
			} 
			elsif(-f $filename && ! -f $outfile){
				print "copy $filename to $outfile\n";
				system("attrib -R $outfile");
				system("COPY /Y $filename $outfile");
			}
			else {
				unlink $outfile;
				die "ERROR: \"$filename\" not available in company directory.\n";
			}	
		}
	}
print "\n*******ALl files are replaced successfully*******\n";

print "\n*******Begin to rewrtied the build scripts*******\n";
foreach my $build (@build_script){
	$build = $target_floder .'\\'.$build;
	my $out = '';
	my $lineNum = 1;
	print "Processing file: $build\n";
	print "==================\n";
	open(INPUT, "<$build") or die "ERROR:Cannot read file: $build";
	while(my $line = <INPUT>){#read file line by line
		#print $line."\n";
		for my $i ( 0 .. $#change_pair_build ) {
			my $pattern = $change_pair_build[$i]->[0];
			my $target =$change_pair_build[$i]->[1];
			
			#~ print $pattern."\n";
			if($line =~ /$pattern/){
				print "\nReplace Pattern: \"$pattern\" to Target: \"$target\" at Line: $lineNum\n";
				my $tmp = trim($line);
				print "Original: $tmp\n";
				$line =~ s/$pattern/$target/g;#global replace the matched string and print out the line number 
				$tmp = trim($line);
				print "Modified: $tmp\n\n";
			}   
		}
		$out .= $line;
		$lineNum++;
	}	
	system("attrib -R $build");
	open(OUTPUT, ">$build") or die "ERROR:Cannot write file: $build";
	print OUTPUT $out;
	close OUTPUT;
	close INPUT;
	print "==================\n\n";
}


print "\n*******All build scripts are rewrtied successfully*******\n";

print "\nBeging to build Infosec OEM Windows Client Components\n";

